/* compile.h
	P.Chongstitvatana

	7 Nov 2005	 project som-v16
	30 Dec 2005	 som-v17
	1 Jan 2007   som-v16a for som-v24 Happy New Year!
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "icname.h"

//#define PROF
//#define DEBUG
//#define VERBOSE

#define PRIVATE			static

#define NAMELEN			32

/* memory map
  M[ system | --> DS   | --> CS | cell ]
            ^          ^        ^      ^
           MAXSYS    MAXDS    MAXCS   MAXMEM

  SS[MAXSS]
*/
#define MAXMEM			800000	// total memory
#define MAXCS			700000	// code segment
#define MAXDS           500000	// data segment
#define MAXSYS			1000	// interface C-som
#define MAXSS			5000	// stack size
#define MAXSTR			256		// max tokstring length
#define MAXLBUF			1000	// input line buffer
#define SSTRING			256		// som-string area

/*
   system area  1 .. MAXSYS-1
   1..80   tokstring-som
   100	   CS base ads
   101 	   mode 1 interactive, 2 compile&run
   110..149 "inputfile"  som-string
   150..199 "input.lst"  som-string
   200..249 "input.obj"  som-string
*/
// som-v24 specific
#define som_src 		110
#define som_lst 		150
#define som_obj 		200
#define CS_ADS  		100
#define MODE_ADS 		101
#define OBJ_SOM30		5678930

#define NL_CHAR			10
#define EOF_CHAR		255

#define	  FALSE		0
#define   FUDGE     16   // scratch area + 3  to chk stkovf
#define   MAXFILE	20
#define	  FREAD		0
#define	  FWRITE	1
#define   FRDWR		2

// -------

#define  eqs(a,b)  (strcmp(a,b) == 0)
#define  nl()		printf("\n")

typedef unsigned char uchar;

extern  int *CS;			/* code segment */
extern  int M[];			/* data, code, cell */
extern  int DS;				/* free data pointer */

// function prototypes
void strpack(int s1, char *s2);
void strunpack(char *s1, int s2);
void eval(int a);				// interp.c
void initfile(void);
void report(void);
void prCode2(FILE *fo, int op);
